function [pu pm pd] = BuildHWprobs(jMax,N,M)

% Initialize the trees for the Up, Middle, and Down probabilities.
pu = zeros(2*jMax+1,N+1);
pm = zeros(2*jMax+1,N+1);
pd = zeros(2*jMax+1,N+1);

% Vector of "J" indices runinng from jMax down to -jMax.
J = [jMax:-1:-jMax];

% Build the probabilities pu(i,j), pm(i,j), and pd(i,j).
for j=1:N+1
	if j<=jMax
		% Tip of the tree.
		for i=jMax+2-j:jMax+j
			pu(i,j) = 1/6 + (J(i)^2*M^2 + J(i)*M)/2;
			pm(i,j) = 2/3 -  J(i)^2*M^2;
			pd(i,j) = 1/6 + (J(i)^2*M^2 - J(i)*M)/2;
		end
	else
		% Remaining nodes.
		for i=1:2*jMax+1
			if i==1
				pu(i,j) =  7/6 + (J(i)^2*M^2 + 3*J(i)*M)/2;
				pm(i,j) = -1/3 -  J(i)^2*M^2 - 2*J(i)*M;
				pd(i,j) =  1/6 + (J(i)^2*M^2 +   J(i)*M)/2;
			elseif i==2*jMax+1
				pu(i,j) =  1/6 + (J(i)^2*M^2 -   J(i)*M)/2;
				pm(i,j) = -1/3 -  J(i)^2*M^2 + 2*J(i)*M;
				pd(i,j) =  7/6 + (J(i)^2*M^2 - 3*J(i)*M)/2;
			else
				pu(i,j) = 1/6 + (J(i)^2*M^2 + J(i)*M)/2;
				pm(i,j) = 2/3 -  J(i)^2*M^2;
				pd(i,j) = 1/6 + (J(i)^2*M^2 - J(i)*M)/2;
			end
		end
	end
end
